import vega from 'vega';
import vegaLite from 'vega-lite';
import vl from 'vega-lite-api';
import { Handler } from 'vega-tooltip';
import { config } from './config';
import { getData } from './getData';
import { viz } from './viz';
//importing the libraries and the viz

//hooks up vega, vegalite
//we use svg as default render
//when we have more than 10k shapes canvas will help performance
vl.register(vega, vegaLite, {
  view: { renderer: 'svg' },
  init: view => { view.tooltip(new Handler().call); }
});

//this asyncrinous function
//extens our vis def. to provide 
//size of window
//visualization fits properly
//config that customizes
//it takes the specification and renders it 
//then we append that to the body componentn
const run = async () => {
  const marks = viz
    .data(await getData())
    .width(window.innerWidth)
    .height(window.innerHeight)
    .autosize({ type: 'fit', contains: 'padding' })
    .config(config);
  
  document.body.appendChild(await marks.render());
};
//run is called to kick up the whole process
run();