import vl from 'vega-lite-api';
//vl is the conventional name to use for this vpi

//vl.markPoint, vl.markLine, vl.markArea instead of markCircle to get different types of visualizations. 

//.scale: zero: false, we do not need the graphics to start at zero
//.fieldN('name'). It shows the name when we are in our points
//markCircle (size: ) changes the size of the points

//.fieldT will interpretate the variable as time
//size inside .encode adds another channel
//same thing for the color inside .encode
//if we are using for example vl.markBar we can 
//use .sort('y') to have like an order in bars. 


export const viz = vl
  .markCircle({ size: 300, opacity: 0.5 })
  .encode(
    vl.x().fieldQ('mpg').scale({ zero: false }),
    vl.y().fieldQ('horsepower').scale({ zero: false }),
    vl.color().fieldN('origin'),
    vl.size().fieldQ('weight'),
    vl.tooltip().fieldN('name')
  );

//visualization specification using vega-lite-api
//iterate to produce visulizations
